Package org.eclipse.m2m.atl.emftvm.trace.impl

## Class TraceLinkSetImpl

- java.lang.Object
- - org.eclipse.emf.common.notify.impl.BasicNotifierImpl
  - - org.eclipse.emf.ecore.impl.BasicEObjectImpl
    - - org.eclipse.emf.ecore.impl.EObjectImpl
      - - org.eclipse.m2m.atl.emftvm.trace.impl.TraceLinkSetImpl

All Implemented Interfaces:
  `org.eclipse.emf.common.notify.Notifier`, `org.eclipse.emf.ecore.EObject`, `org.eclipse.emf.ecore.InternalEObject`, `TraceLinkSet`

    public class TraceLinkSetImpl
    extends org.eclipse.emf.ecore.impl.EObjectImpl
    implements TraceLinkSet

An implementation of the model object 'Link Set'.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl

`org.eclipse.emf.ecore.impl.BasicEObjectImpl.EPropertiesHolder, org.eclipse.emf.ecore.impl.BasicEObjectImpl.EPropertiesHolderBaseImpl, org.eclipse.emf.ecore.impl.BasicEObjectImpl.EPropertiesHolderImpl`

### Nested classes/interfaces inherited from class org.eclipse.emf.common.notify.impl.BasicNotifierImpl

`org.eclipse.emf.common.notify.impl.BasicNotifierImpl.EAdapterList<E extends java.lang.Object & org.eclipse.emf.common.notify.Adapter>, org.eclipse.emf.common.notify.impl.BasicNotifierImpl.EObservableAdapterList, org.eclipse.emf.common.notify.impl.BasicNotifierImpl.EScannableAdapterList`

### Nested classes/interfaces inherited from interface org.eclipse.emf.ecore.InternalEObject

`org.eclipse.emf.ecore.InternalEObject.EStore`

### Field Summary

Fields
`protected org.eclipse.emf.common.util.EList<SourceElementList>` `defaultSourceElementLists` The cached value of the '`Default Source Element Lists`' containment reference list.
`protected org.eclipse.emf.common.util.EList<SourceElement>` `defaultSourceElements` The cached value of the '`Default Source Elements`' reference list.
`protected java.util.Map<java.util.List<java.lang.Object>,​SourceElementList>` `defaultSourceObjectLists` Lookup table of referred objects to `SourceElementList`s.
`protected java.util.Map<org.eclipse.emf.ecore.EObject,​SourceElement>` `defaultSourceObjects` Lookup table of referred objects to `SourceElement`s.
`protected java.util.Map<java.lang.String,​TracedRule>` `linksByRuleName` Lookup table of traced rules by name.
`protected org.eclipse.emf.common.util.EList<TracedRule>` `rules` The cached value of the '`Rules`' containment reference list.

### Fields inherited from class org.eclipse.emf.ecore.impl.EObjectImpl

`eAdapters, eContainer, eContainerFeatureID, EDELIVER, EDYNAMIC_CLASS, eFlags, ELAST_EOBJECT_FLAG, ELAST_NOTIFIER_FLAG, eProperties, EPROXY`

### Fields inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl

`EVIRTUAL_GET, EVIRTUAL_IS_SET, EVIRTUAL_NO_VALUE, EVIRTUAL_SET, EVIRTUAL_UNSET`

### Fields inherited from interface org.eclipse.emf.ecore.InternalEObject

`EOPPOSITE_FEATURE_BASE`

### Constructor Summary

Constructors
`protected` `TraceLinkSetImpl()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `clear()`
`java.lang.Object` `eGet​(int featureID, boolean resolve, boolean coreType)`
`org.eclipse.emf.common.notify.NotificationChain` `eInverseAdd​(org.eclipse.emf.ecore.InternalEObject otherEnd, int featureID, org.eclipse.emf.common.notify.NotificationChain msgs)`
`org.eclipse.emf.common.notify.NotificationChain` `eInverseRemove​(org.eclipse.emf.ecore.InternalEObject otherEnd, int featureID, org.eclipse.emf.common.notify.NotificationChain msgs)`
`boolean` `eIsSet​(int featureID)`
`boolean` `eNotificationRequired()`
`void` `eNotify​(org.eclipse.emf.common.notify.Notification notification)`
`void` `eSet​(int featureID, java.lang.Object newValue)`
`protected org.eclipse.emf.ecore.EClass` `eStaticClass()`
`void` `eUnset​(int featureID)`
`SourceElement` `getDefaultSourceElement​(java.lang.Object sourceElement)` Returns the default `SourceElement` for the given source object.
`org.eclipse.emf.common.util.EList<SourceElementList>` `getDefaultSourceElementLists()`
`org.eclipse.emf.common.util.EList<SourceElement>` `getDefaultSourceElements()`
`SourceElementList` `getDefaultSourceElements​(java.util.List<?> sourceElements)` Returns the default `SourceElementList` for the given source objects.
`TracedRule` `getLinksByRule​(java.lang.String rule, boolean create)`
`org.eclipse.emf.common.util.EList<TracedRule>` `getRules()`
`java.lang.String` `toString()`

### Methods inherited from class org.eclipse.emf.ecore.impl.EObjectImpl

`eAdapters, eBasicAdapters, eBasicProperties, eBasicSetContainer, eClass, eContainerFeatureID, eDeliver, eInternalContainer, eInvoke, eIsProxy, eProperties, eSetClass, eSetDeliver, eSetProxyURI`

### Methods inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl

`eAddVirtualValue, eAllContents, eBaseStructuralFeatureID, eBasicRemoveFromContainer, eBasicRemoveFromContainerFeature, eBasicSetContainer, eComputeVirtualValuesCapacity, eContainer, eContainerAdapterArray, eContainingFeature, eContainmentFeature, eContainmentFeature, eContains, eContents, eCrossReferences, eDerivedOperationID, eDerivedOperationID, eDerivedStructuralFeatureID, eDerivedStructuralFeatureID, eDirectResource, eDynamicBasicRemoveFromContainer, eDynamicClass, eDynamicFeature, eDynamicFeatureID, eDynamicGet, eDynamicGet, eDynamicGet, eDynamicInverseAdd, eDynamicInverseAdd, eDynamicInverseRemove, eDynamicInverseRemove, eDynamicInvoke, eDynamicInvoke, eDynamicIsSet, eDynamicIsSet, eDynamicIsSet, eDynamicSet, eDynamicSet, eDynamicSet, eDynamicUnset, eDynamicUnset, eDynamicUnset, eGet, eGet, eGet, eHasSettings, eInternalResource, eInverseAdd, eInverseRemove, eInvocationDelegate, eInvoke, eIsSet, eObjectForURIFragmentSegment, eOpenGet, eOpenIsSet, eOpenSet, eOpenUnset, eProxyURI, eRemoveVirtualValue, eResolveProxy, eResource, eSet, eSetDirectResource, eSetResource, eSetStore, eSetting, eSettingDelegate, eSettings, eSetVirtualIndexBits, eSetVirtualValue, eSetVirtualValues, eStaticFeatureCount, eStaticOperationCount, eStore, eUnset, eURIFragmentSegment, eVirtualBitCount, eVirtualGet, eVirtualGet, eVirtualIndex, eVirtualIndexBits, eVirtualIsSet, eVirtualSet, eVirtualUnset, eVirtualValue, eVirtualValues`

### Methods inherited from class org.eclipse.emf.common.notify.impl.BasicNotifierImpl

`eBasicAdapterArray, eBasicHasAdapters`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.eclipse.emf.ecore.EObject

`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eInvoke, eIsProxy, eIsSet, eResource, eSet, eUnset`

### Methods inherited from interface org.eclipse.emf.common.notify.Notifier

`eAdapters, eDeliver, eSetDeliver`

### Field Detail

#### rules

    protected org.eclipse.emf.common.util.EList<TracedRule> rules

The cached value of the '`Rules`' containment reference list.

See Also:
  `getRules()`

#### defaultSourceElements

    protected org.eclipse.emf.common.util.EList<SourceElement> defaultSourceElements

The cached value of the '`Default Source Elements`' reference list.

See Also:
  `getDefaultSourceElements()`

#### defaultSourceElementLists

    protected org.eclipse.emf.common.util.EList<SourceElementList> defaultSourceElementLists

The cached value of the '`Default Source Element Lists`' containment reference list.

See Also:
  `getDefaultSourceElementLists()`

#### defaultSourceObjects

    protected final java.util.Map<org.eclipse.emf.ecore.EObject,​SourceElement> defaultSourceObjects

Lookup table of referred objects to `SourceElement`s.

#### defaultSourceObjectLists

    protected final java.util.Map<java.util.List<java.lang.Object>,​SourceElementList> defaultSourceObjectLists

Lookup table of referred objects to `SourceElementList`s.

#### linksByRuleName

    protected final java.util.Map<java.lang.String,​TracedRule> linksByRuleName

Lookup table of traced rules by name.

### Constructor Detail

#### TraceLinkSetImpl

    protected TraceLinkSetImpl()

### Method Detail

#### eStaticClass

    protected org.eclipse.emf.ecore.EClass eStaticClass()

Overrides:
  `eStaticClass` in class `org.eclipse.emf.ecore.impl.EObjectImpl`

#### getRules

    public org.eclipse.emf.common.util.EList<TracedRule> getRules()

Specified by:
  `getRules` in interface `TraceLinkSet`
Returns:
  the value of the 'Rules' containment reference list.
See Also:
  `TracePackage.getTraceLinkSet_Rules()`, `TracedRule.getLinkSet()`

#### getDefaultSourceElements

    public org.eclipse.emf.common.util.EList<SourceElement> getDefaultSourceElements()

Specified by:
  `getDefaultSourceElements` in interface `TraceLinkSet`
Returns:
  the value of the 'Default Source Elements' reference list.
See Also:
  `TracePackage.getTraceLinkSet_DefaultSourceElements()`, `SourceElement.getDefaultFor()`

#### getDefaultSourceElementLists

    public org.eclipse.emf.common.util.EList<SourceElementList> getDefaultSourceElementLists()

Specified by:
  `getDefaultSourceElementLists` in interface `TraceLinkSet`
Returns:
  the value of the 'Default Source Element Lists' containment reference list.
See Also:
  `TracePackage.getTraceLinkSet_DefaultSourceElementLists()`, `SourceElementList.getDefaultFor()`

#### getDefaultSourceElement

    public SourceElement getDefaultSourceElement​(java.lang.Object sourceElement)

Returns the default `SourceElement` for the given source object.

Specified by:
  `getDefaultSourceElement` in interface `TraceLinkSet`
Parameters:
  `sourceElement` - the source object that the `SourceElement` points to
Returns:
  the default `SourceElement` for the given source object

#### getDefaultSourceElements

    public SourceElementList getDefaultSourceElements​(java.util.List<?> sourceElements)

Returns the default `SourceElementList` for the given source objects.

Specified by:
  `getDefaultSourceElements` in interface `TraceLinkSet`
Parameters:
  `sourceElements` - the source objects that the `SourceElementList` elements point to
Returns:
  the default `SourceElementList` for the given source objects

#### getLinksByRule

    public TracedRule getLinksByRule​(java.lang.String rule,
                                     boolean create)

Specified by:
  `getLinksByRule` in interface `TraceLinkSet`

#### clear

    public void clear()

Specified by:
  `clear` in interface `TraceLinkSet`

#### eInverseAdd

    public org.eclipse.emf.common.notify.NotificationChain eInverseAdd​(org.eclipse.emf.ecore.InternalEObject otherEnd,
                                                                       int featureID,
                                                                       org.eclipse.emf.common.notify.NotificationChain msgs)

Overrides:
  `eInverseAdd` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

#### eInverseRemove

    public org.eclipse.emf.common.notify.NotificationChain eInverseRemove​(org.eclipse.emf.ecore.InternalEObject otherEnd,
                                                                          int featureID,
                                                                          org.eclipse.emf.common.notify.NotificationChain msgs)

Overrides:
  `eInverseRemove` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

#### eGet

    public java.lang.Object eGet​(int featureID,
                                 boolean resolve,
                                 boolean coreType)

Specified by:
  `eGet` in interface `org.eclipse.emf.ecore.InternalEObject`
Overrides:
  `eGet` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

#### eSet

    public void eSet​(int featureID,
                     java.lang.Object newValue)

Specified by:
  `eSet` in interface `org.eclipse.emf.ecore.InternalEObject`
Overrides:
  `eSet` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

#### eUnset

    public void eUnset​(int featureID)

Specified by:
  `eUnset` in interface `org.eclipse.emf.ecore.InternalEObject`
Overrides:
  `eUnset` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

#### eIsSet

    public boolean eIsSet​(int featureID)

Specified by:
  `eIsSet` in interface `org.eclipse.emf.ecore.InternalEObject`
Overrides:
  `eIsSet` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

#### eNotificationRequired

    public boolean eNotificationRequired()

Specified by:
  `eNotificationRequired` in interface `org.eclipse.emf.ecore.InternalEObject`
Overrides:
  `eNotificationRequired` in class `org.eclipse.emf.common.notify.impl.BasicNotifierImpl`

#### eNotify

    public void eNotify​(org.eclipse.emf.common.notify.Notification notification)

Specified by:
  `eNotify` in interface `org.eclipse.emf.common.notify.Notifier`
Overrides:
  `eNotify` in class `org.eclipse.emf.common.notify.impl.BasicNotifierImpl`